// URL_Window.h

#include <AppKit.h>
#include <InterfaceKit.h>
#include <File.h>
#include <String.h>
#include <VolumeRoster.h>
#include <Volume.h>
#include <Query.h>
#include <Path.h>

#include "URL_MenuItem.h"

#ifndef __URL_WINDOW_H__
#define __URL_WINDOW_H__

class URL_Window : public BWindow
{
public:
					URL_Window			(BFile * m_settings_file);
					~URL_Window			(void);
					
	virtual void	MessageReceived 	(BMessage * a_message);
	virtual void	Quit				(void);

private:	
			void	DelayedInit			(void);
			void	Save				(void);
			void	PrintErrorMessage	(const char * a_text, int32 a_status);

			void	SaveSettings		(void);
			void	ReadSettings		(void);
			
			void	PopulateList		(void);
			void	BuildAppDropdown	(void);
			void	DisplayDescriptions	(void);
			void	EmptyAppDropdown	(void);
			void	EmptyListview		(void);
			
		BList	*	GetAppRefsByQuery	(const char * app_sig);
			
			void	DealWithTypeChanges	(BMessage * a_msg);

		BString *	GetCurrentType		(void);
			
			void	SetPrefApp			(BMessage * a_message);

			bool	IsWindowOffScreen		(void);
			void	CenterWindowOnScreen	(void);
			void	PushWindowOnScreen		(void);
	
	// essentials
	BFile		*	m_settings_file;
	BMimeType	*	m_mime_type;	
	BMessenger	*	m_win_messenger;
	
	// interface
	BBox		*	m_topbox;
	BBox		*	m_details_box;
	BListView	*	m_listview;
	BTextView	*	m_longdescription;
	BMenuField	*	m_menufield;
	BMenu		*	m_pref_app_menu;
};

#endif

